//#define _X86_ 1
extern "C"{
#include <ntddk.h>
//#include <intrin.h>
}
#define VDONGLE_TYPE 40000
#define CTL0 CTL_CODE(VDONGLE_TYPE,0x0800,METHOD_BUFFERED,FILE_READ_ACCESS)
#define CTL1 CTL_CODE(VDONGLE_TYPE,0x0FFF,METHOD_BUFFERED,FILE_READ_ACCESS)
#define CTL_MASK (CTL0^CTL1)

struct TAccessCounter{	/* Zähler für die Statistik */
 ULONG out;	/* OUT-Zugriffe */
 ULONG in;	/* IN-Zugriffe */
 ULONG fail;	/* Nicht gefunden ODER Nicht unterstützter IO-Befehl */
 ULONG resv;
};

struct TFileStatistics{	/* Datei-Info */
 ULONG fs_out;
 ULONG fs_in;
};

struct DIOCPARAMS{	/* IOCTL-Parameter */
 ULONG dwIoControlCode;
 PVOID lpvInBuffer;
 ULONG cbInBuffer;
 PVOID lpvOutBuffer;
 ULONG cbOutBuffer;
 ULONG cbBytesReturned;			/* hier: kein Zeiger! */
 void PutResult(ULONG data, ULONG datalen);
 NTSTATUS ctrl();
};

/***********************
 ** Globale Variablen **
 ***********************/
ULONG PortBase=0x378;	/* Portadresse der Emulation via IOPM */
ULONG P586Base=0x378;	/* Portadresse der Emulation via Debugreg. */
ULONG PhysBase=0x378;	/* Physikalische Portadresse */
ULONG KillBase=0;	/* Zu überschreibende Portadresse im BIOS */

TAccessCounter AC;
TFileStatistics	FileSta;

PUSHORT MemAdr;		/* Speicheradresse */
ULONG MemLen;		/* Speicherlänge in Bytes */
ULONG MemAlloc;		/* momentane Seitenzahl (als Cache) */
PUSHORT MemIdx;		/* Umlauf-Zeiger für Vergleich */
#define BUFFERLEN 2048	/* Puffer-Länge in WORDs (wie früher) 4KByte */
USHORT Buffer[BUFFERLEN];	/* Puffer, diesmal statisch */
/* Aufbau des Puffers:
 * 1 WORD Anzahl OUT-Befehle (Füllstand in Bytes = (Anzahl+2)*2)
 * x WORD OUT-Befehle, Lo=Byte, Hi=Offset 0..3
 * 1 WORD IN-Befehl, Lo=Byte, Hi=Offset+4 4..7 */
UCHAR EmuMode;		/* Emulation Aus/Wiedergabe/Aufnahme */
UCHAR Tick;		/* Knackgeräusch Aus/Laut/Leiser (ungenutzt) */
UCHAR Trap;		/* Trap-Modus Aus/IOPM/586Debug */
UCHAR Dirty;		/* Dirty-Flag */

USHORT ChangedPort;	/* zur Rücknahme des Patches beim Beenden */
USHORT WasAddr;
LARGE_INTEGER OldInt1;	/* bleibt Null ohne Pentium */

LARGE_INTEGER IDT;

static void NewInt1();
static bool MemReAlloc(ULONG);

/*****************************
 ** Debug-Register und Int1 **
 *****************************/
#define USE_DA	0x0000		/* 0 oder 0x2000 */
#define PRE_ALLOC 0x100000	/* 1 MB fester Speicher beim Anlernen */

void __declspec(naked) LoadDR() {
/* Lade Debugregister, VR: EAX */
 __asm{	mov	eax,DR7
	btr	eax,13		/* zuerst: Debugregister-Trap ausschalten */
	mov	DR7,eax
	_emit	0x0F		// mov eax,cr4
	_emit	0x20
	_emit	0xE0
	BTS	eax,3		/* PENTIUM Debug Extension aktivieren */
	_emit	0x0F		// mov cr4,eax
	_emit	0x22
	_emit	0xE0
	mov	eax,[P586Base]
	mov	DR0,eax
	mov	eax,DR7
	or	eax,0x000E0303|USE_DA
	btr	eax,16	/* EAX=xxxx xxxx xxxx 1110 xxXx xx11 xxxx xx11 */
	mov	DR7,eax
	ret
 }
}

void __declspec(naked) UnloadDR() {
/* Entlade Debugregister, VR: EAX */
 __asm{	mov	eax,DR7
	and	eax,~(0x000F0003|USE_DA)
	mov	DR7,eax	/* EAX=xxxx xxxx xxxx 0000 xxXx xxxx xxxx xx00 */
	ret
 }
}

void __declspec(naked) SetHook1() {
/* PE: CX:EAX=neue Adresse für INT1 */
/* PA: CX:EAX=alte Adresse von INT1 */
 __asm{	sidt	[IDT]
	mov	edx,cr0
	push	edx
	 btr	edx,16			/* Supervisor Mode Write Protect */
	 mov	cr0,edx
	 mov	edx,[dword ptr IDT+2]
	 xchg	ax,[edx+0x08]		/* Low-Teil Offset */
	 rol	eax,16
	 xchg	ax,[edx+0x0E]		/* High-Teil Offset */
	 rol	eax,16
	 xchg	cx,[edx+0x0A]		/* Segment */
	pop	edx
	mov	cr0,edx
	ret
 }
}

void __declspec(naked) SwapID() {
 __asm{	pushfd
	pop	eax
	btc	eax,21
	push	eax
	popfd
	ret
 }
}

void GetInt1() {
/* PA: [OldInt1]=Adresse von INT1, aber nur beim Pentium */
 __asm{	call	SwapID
	mov	esi,eax
	call	SwapID
	cmp	esi,eax
	jz	no_586
	sidt	[IDT]
	mov	esi,[dword ptr IDT+2]	/* BASE */
	mov	edi,offset OldInt1
	cld
	mov	ax,[esi+0x08]		/* Low-Teil Offset */
	stosw
	mov	ax,[esi+0x0E]		/* High-Teil Offset */
	stosw
	movzx	eax,word ptr [esi+0x0A]	/* Segment */
	stosd
no_586:
 }
}

void __declspec(naked) HookInt1() {
/* Faule Annahme: bei INT1 befindet sich bereits ein gültiger Gate-Deskriptor
/* VR: EAX,CX,EDX; EFlags unverändert */
 __asm{	pushfd
	 cli
	 mov	eax,offset NewInt1
	 mov	cx,cs
	 cmp	[dword ptr OldInt1],0
	 jz	no_586
	 call	SetHook1
no_586:
	popfd
	ret
 }
}

void __declspec(naked) UnhookInt1() {
/* VR: EAX,CX,ESI; EFlags unverändert */
 __asm{	pushfd
	 cli
	 mov	eax,[dword ptr OldInt1]
	 mov	cx,[word ptr OldInt1+4]
	 cmp	[dword ptr OldInt1],0
	 jz	no_586
	 call	SetHook1
no_586:
	popfd
	ret
 }
}

/***************************
 ** Portzugriffe und Trap **
 ***************************/

void __declspec(naked) Compare1() {
/* Einen Stringvergleich durchführen
 * PE: EAX=laufende Adresse im "Mem"
 *     CLD!!
 * PA: EAX=Adresse hinter dem verglichenen String
 *     Z=1: Vergleich OK, dann [EAX-2]=IN-Byte (außerdem im Puffer)
 * VR: EAX,ECX,ESI,EDI
 */
 __asm{	mov	edi,offset Buffer
	mov	esi,eax
	movzx	eax,word ptr [esi]	//Anzahl OUTs
	inc	eax
	mov	ecx,eax		//Längen-WORD + Anzahl OUTs
	inc	eax
	lea	eax,[esi+eax*2]	//Neue Adresse
//nun: ESI,ECX und EDI gesetzt sowie EAX (das neue Ende) berechnet
	repe	cmpsw		//Länge und OUTs vergleichen
	jnz	e
	movsb			//IN-Byte in den Puffer
	cmpsb			//IN-Adresse vergleichen
e:	ret
 }
}

void __declspec(naked) Compare2() {
/*Noch einen Stringvergleich durchführen, diesmal wird ein
 * "Fehler-Koeffizient" geliefert, um die beste Passung zu finden
 * Der String-Vergleich wird mit den jeweils LETZTEN OUT-Befehlen gemacht//
 * eine unterschiedliche IN-Adresse liefert den maximal möglichen
 * Fehlerkoeffizient
 * PE: EAX=laufende Adresse im "Mem"
 *     CLD!!
 * PA: EAX=Adresse hinter dem verglichenen String
 *     ECX=Fehler-Koeffizient (je kleiner, desto besser)
 * VR: EAX,ECX,ESI
 */
 __asm{	mov	esi,eax
	movzx	eax,word ptr [esi]	//Anzahl OUTs in Mem
	lea	eax,[esi+eax*2+4]	//Neue Adresse
	push	edi
	push	eax
	push	edx
	 mov	edi,offset Buffer
//nun: ESI und EDI gesetzt sowie EAX (das neue Ende) berechnet
	 movzx	ecx,word ptr [edi]	//Anzahl OUTs im Puffer
	 mov	al,[eax-1]		//IN-Adresse in Mem
	 cmp	al,[edi+ecx*2+3]	//Vgl. IN-Adresse im Puffer
	 jne	bad			//Ungleich? Ganz schlecht!
	 movzx	eax,word ptr [esi]	//Anzahl OUTs in Mem
	 sub	eax,ecx			//Differenz=Anzahl Fehler
	 js	nega
	 add	edi,2			//hier: mehr in Mem als in Buffer
	 lea	esi,[esi+eax*2+2]	//vordere OUTs in Mem übergehen
	 jmp	posi
nega:					//hier: mehr in Buffer als in Mem
	 neg	eax			//Differenz positiv machen
	 sub	ecx,eax			//verbleibende zu vergleichende OUTs
	 add	esi,2
	 lea	edi,[edi+eax*2+2]	//vordere OUTs in Buffer übergehen
posi:	 mov	edx,eax			//Anzahl der Fehler durch Längendiff.
	 add	edx,eax
	 add	edx,eax			//Längenfehler mit Drei bewerten
//nun: ESI und EDI auf den "Anfang vom Ende" der OUT-Listen gesetzt,
//ECX=Länge (Mindest-Anzahl OUTs) und EDX(!)=Fehlerzahl
	 jecxz	sf			//wenn keine OUT-Bytes
sl:	 cmpsb
	 je	eqd
	 inc	edx			//Datenfehler mit Eins bewerten
eqd:	 cmpsb
	 je	eqa
	 inc	edx			//Adreßfehler mit Zwei bewerten
	 inc	edx
eqa:	 loop	sl
sf:	 push	edx
	 jmp	pe
bad:	 push	-1
pe:	 pop	ecx
	pop	edx
	pop	eax
	pop	edi
	ret
 }
}

void __declspec(naked) ProcessBuffer() {		//CLD!!
//Routine wird bei IN-Befehl von PutInBuffer() aufgerufen
 __asm{	cld
	push	offset resetbuffer	//bei RET ausführen
	mov	dl,[EmuMode]
	dec	dl
	jz	play		//bei EmuMode=1
	dec	dl
	jz	record		//bei EmuMode=2
	ret
play:
	mov	eax,[MemLen]
	or	eax,eax
	jz	noplay	//Notbremse - und Null liefern
	mov	ebx,[MemAdr]
	add	ebx,eax		//Ende ins Register EBX
	mov	eax,[MemIdx]
	mov	edx,eax		//Startpunkt merken in EDX
pl:	call	Compare1
	jz	found
	cmp	eax,ebx		//Speicher-Ende erreicht?
	jb	p2
	mov	eax,[MemAdr]	//weiter von vorn
p2:	cmp	eax,edx		//Am Startpunkt angekommen?
	jnz	pl
	inc	[AC.fail]
	//vielleicht ist das Dongleabfrageprogramm schlau und doof zugleich!
	//(Schickt zufällige Daten ans Dongle und will doch immer die gleiche
	// Byte-Sequenz beim Auslesen.)
	//Oder aber im zweiten Versuch den besten Treffer finden!
	//(Das ist zeitraubender, deshalb im zweiten Versuch)
	push	ebp
	 push	-1
	 pop	edi
suche2:
	 call	Compare2
	 cmp	ecx,edi
	 jnc	nomin		//Z=1 -> HIER: Nur erstes Minimum nehmen
	 mov	edi,ecx		//neues Minimum merken
	 mov	ebp,eax		//(End-)Adresse merken
nomin: cmp	eax,ebx		//Speicher-Ende erreicht?
	 jb	j2
	 mov	eax,[MemAdr]	//weiter von vorn
j2:	 cmp	eax,edx
	 jnz	suche2		//Eine ganze Runde herum
	 call	Compare2	//noch einer zum Vorrücken von EAX
	 cmp	edi,-1		//Überhaupt etwas brauchbares gefunden?
	 je	nothing_found
	 mov	cl,[ebp-2]	//das nunmehr am besten passende IN-Byte
	pop	ebp
	cmp	[AC.resv],edi
	jnc	found_cl
	mov	[AC.resv],edi//Maximum eintragen
	jmp	found_cl
nothing_found:
	pop	ebp
found:
	mov	cl,[eax-2]	//das gesuchte IN-Byte
found_cl:
	cmp	eax,ebx		//Speicher-Ende erreicht?
	jb	p3
	mov	eax,[MemAdr]	//weiter von vorn
p3:	mov	[MemIdx],eax
	xchg	eax,ecx		//gotcha(r) mit einem Befehlsbyte
noplay:
	ret
record:
	push	eax		//IN-Byte retten zum Durchreichen
	 mov	esi,offset Buffer
	 movzx	eax,word ptr [esi]	//Anzahl OUTs
	 add	eax,2		//Anzahl WORDs
	 push	eax
	  add	eax,eax		//Anzahl Bytes
	  mov	edi,[MemLen]
	  add	eax,edi		//neues MemLen
// Das dynamische Speicher-Vergrößern funktioniert mit NT nicht richtig!
	  cmp	eax,PRE_ALLOC
	  ja	recfailure
	  mov	[MemLen],eax
//	  call	MemReAlloc	//Speicher vergrößern
	 pop	ecx
	 mov	eax,[MemAdr]	//ggf. neue(!) Adresse
	 add	edi,eax		//EDI=altes [MemLen] dazu
//	 or	eax,eax
	pop	eax		//da ist das IN-Byte wieder!
//	jz	recfailure
	rep	movsw		//an Puffer anhängen
	mov	[Dirty],1
	ret
recfailure:
	 pop	ecx
	pop	eax
	inc	[AC.fail]
	ret
resetbuffer:
	mov	word ptr [Buffer],0
	ret
 }
}

void __declspec(naked) PutInBuffer() {
/* PE: AX=In/Out-Speicherwort
 * PA: CY=1 bei Fehler
 *     AL=IN-Byte
 * VR: alle
 */
 __asm{	mov	esi,offset Buffer
	movzx	edx,word ptr [esi]	//Aktuelle String-Länge
	or	edx,edx		//Puffer leer?
	jz	f1		//Dann auch immer eintragen!
	cmp	[esi+edx*2],ax	//Schon vorhanden?
	jz	e		//ja, ignorieren - und CY=0
f1:	inc	edx
	mov	[esi+edx*2],ax	//Befehl eintragen
	bt	eax,10		//IN-Befehl?
	jc	ProcessBuffer
	cmp	edx,BUFFERLEN	//Puffer voll?
	cmc
	jc	e		//Fehler, nichts tun!
	mov	[esi],dx	//String ist länger geworden...
e:	ret
 }
}

void __declspec(naked) IOCallback2() {
//fast dieselbe Routine, für den Aufruf durch den Hardwarebreakpoint
//mit dem wichtigen Unterschied, daß der I/O-Zugriff bereits gemacht wurde
//und hier KEINESFALLS ein Zugriff erfolgen darf, sonst Rekursion!
//(Ausnahme: die emulierte Portadresse ist nicht gleich der physikalischen.)
 __asm{	sub	edx,[P586Base]
	cmp	edx,3
	je	bypass		//Die vierte Portadresse ganz ignorieren
	cmp	ecx,4
	je	O
	inc	[AC.in]
	cmp	[EmuMode],1	//Wiedergabe?
	je	no_phys_read
	mov	ecx,[PhysBase]
	cmp	ecx,[P586Base]	//unterschiedlich?
	je	no_phys_read
	add	edx,ecx
	in	al,dx		//IN-Befehl auf richtiger Adresse nachholen
	sub	edx,ecx
no_phys_read:
	mov	ah,dl
	or	ah,4		//Bit 2 als IN-Kennung setzen
	jmp	put
O:
	inc	[AC.out]
	cmp	[EmuMode],1	//Wiedergabe?
	je	no_phys_write
	mov	ecx,[PhysBase]
	cmp	ecx,[P586Base]	//unterschiedlich?
	je	no_phys_write
	add	edx,ecx
	out	dx,al		//OUT-Befehl auf richtiger Adresse nachholen
	sub	edx,ecx
no_phys_write:
	mov	ah,dl
put:	call	PutInBuffer	//liefert CY, wenn CallWindows erforderlich
bypass:	ret
 }
}

void __declspec(naked) NewInt1() {
 __asm{	pushad
	pushfd
	 mov	eax,DR6
	 btr	eax,0		//Zugriff auf Portadresse..Portadresse+3?
	 jc	access
	 btr	eax,13		//Zugriff auf Debug-Register?
	 jc	accdr
	popfd
	popad
	jmp	fword ptr cs:[OldInt1]	//weiter (zu SoftICE o.ä.)
accdr:	//wenn schlimme Finger am Debugregister spielen
	popfd
	mov	DR6,eax
	call	LoadDR		//nachladen!
	popad
	iretd
access:
//bei jedem Portzugriff (LPT) steht in DX die Portadresse
//Faule Annahme: in AL steht das Datenbyte
	popfd
	mov	DR6,eax		//Bit in DR6 löschen
	mov	ebp,esp		//CRS adressierbar machen (ab EIP -4!)
	push	ds
	push	es
	 mov	di,ss
	 bt	dword ptr [ebp+0x28],17	//V86-Mode?
	 jnc	protmode
//Opcode beschaffen; Adreßrechnung je nach V86- oder Protmode
	 mov	ds,di
	 movzx	eax,word ptr [ebp+0x24]	//Real-Mode-CS
	 shl	eax,4
	 add	eax,[ebp+0x20]
	 jmp	fromvm
//Annahme: Zugriff im Protected Mode mit lesbarem Code-Segment
protmode:
	 lds	eax,fword ptr [ebp+0x20] //Code-Zeiger
fromvm:
	 mov	al,[eax-1]		//Opcode
	 mov	ds,di
	 mov	es,di
//Richtung des Portzugriffs (Lesen oder Schreiben) ermitteln
	 xor	ecx,ecx
	 cmp	al,0xEC			//IN al,dx
	 je	supported		//mit AL=gelesenes Byte
	 BTS	ecx,2
	 cmp	al,0xEE			//OUT dx,al
	 je	supported		//mit AL=geschriebenes Byte
	 inc	[AC.fail]
	 jmp	no_simple_IO
supported:
	 mov	eax,[ebp+0x1C]		//Client_EAX
	 push	ecx
	  call	IOCallback2		//etwas anders als IOCallback!
	 pop	ecx
	 cmp	ecx,4
	 je	no_simple_IO
	 mov	[ebp+0x1C],al		//Byte ggf. modifizieren
no_simple_IO:
	pop	es
	pop	ds
	popad
	iretd
 }
}

/************************
 ** Speicherverwaltung **
 ************************/
const ULONG MEMPAGE=0x10000;		//hier: Speicher in 64-K-Schritten anfordern

bool MemReAlloc(ULONG newsize) {
/* Suchspeicher belegen, verändern oder freigeben
 * PA: siehe Memxxx-Speicherzellen; Adresse=0 bei Fehler
 */
 MemLen=newsize;
 if (EmuMode == 2) return false;	// Aufnahme? Nichts allozieren, sonst Absturzgefahr
 USHORT*oldadr=MemAdr;
 if (newsize) {
  newsize = (newsize+MEMPAGE-1)&~(MEMPAGE-1);
  if (newsize == MemAlloc) return true;
  ULONG minsize = MemAlloc;
  if (minsize > newsize) minsize = newsize;
  USHORT*newadr=(USHORT*)ExAllocatePool(NonPagedPool,newsize);
  if (!newadr) return false;
  ULONG offset=MemIdx-oldadr;
  if (offset>=newsize) offset=0;
//  __movsd(newadr,oldadr,minsize>>2);
  memcpy(newadr,oldadr,minsize);
  MemAdr=newadr;
  MemAlloc = newsize;
  MemIdx=newadr+offset;
 }else{
  MemAdr=0;
  MemAlloc=0;
  MemIdx=0;
 }
 if (oldadr) ExFreePool(oldadr);
 return true;
}

/******************
 ** Datei-Arbeit **
 ******************/

BOOLEAN __declspec(naked) IsConsistent() {
/* Prüft Konsistenz und entfernt Double-Outs
 * PE: [MemAdr] und [MemLen]
 * PA: CY=0, wenn konsistent
 *     [MemAdr] und [MemLen] ggf. verändert
 * VR: AL
 */
 __asm{	pushad
	 mov	esi,[MemAdr]	//Anfangsadresse
	 mov	edi,esi
	 mov	ebx,esi
	 add	ebx,[MemLen]	//Endadresse+1
	 xor	eax,eax
	 xor	ecx,ecx
	 mov	[FileSta.fs_out],eax
	 mov	[FileSta.fs_in],eax
	 jmp	f		//Fußgesteuerte Pseudo-Kopf-Schleife
la:	 mov	ebp,edi		//Zeiger auf Byte-Out-Zahl
	 lodsw
	 stosw
	 cmp	eax,BUFFERLEN
	 ja	e		//Fehler - Längen-WORD zu groß!
	 inc	[FileSta.fs_in]
	 add	[FileSta.fs_out],eax
	 xchg	ecx,eax
	 jecxz	nl
	 mov	edx,0xFFFF	//Vorhergehender OUT-Befehl
li:	 lodsw
	 cmp	ah,3		//Nur OUT-Befehle (AH=0, 1 oder 2)?
	 jnc	e		//Fehler: Kein OUT-Byte
	 cmp	eax,edx
	 je	leq		//Doppel-OUT nicht schreiben
	 stosw
	 jmp	lne
leq:	 dec	word ptr [ebp]	//ein OUT weniger!
	 dec	[FileSta.fs_out]
lne:	 xchg	edx,eax		//OUT-Befehl merken
	 loop	li
nl:	 lodsw
	 stosw
	 sub	ah,4
	 cmp	ah,3
	 jnc	e		//Fehler: Kein IN-Byte
f:	 cmp	esi,ebx
	 jc	la
	 jnz	e		//nicht glatt? Auch Fehler!
	 cmp	esi,edi		//Gab es Double-Outs?
	 je	ex		//nein, keine Speicherkorrektur
	 xchg	eax,edi
	 sub	eax,[MemAdr]	//neue Länge
	 call	MemReAlloc	//Speicher verkleinern (sollte OK liefern)
	 clc
	 jmp	ex
e:	 stc
ex:	popad
	setnc	al
	ret
 }
}

NTSTATUS LoadFile(PCWSTR FileName,BOOLEAN append) {
 UNICODE_STRING filename;
 HANDLE hFile;
 OBJECT_ATTRIBUTES oa;
 IO_STATUS_BLOCK iosb;
 FILE_STANDARD_INFORMATION fsi;
 ULONG oldsize, newsize;

 RtlInitUnicodeString(&filename,FileName);
 InitializeObjectAttributes(&oa,&filename,OBJ_CASE_INSENSITIVE,NULL,NULL);

 ZwCreateFile(&hFile,GENERIC_READ|SYNCHRONIZE,&oa,&iosb,NULL,
   FILE_ATTRIBUTE_NORMAL,FILE_SHARE_READ,FILE_OPEN,
   FILE_SEQUENTIAL_ONLY|FILE_SYNCHRONOUS_IO_NONALERT,NULL,0);
 if (NT_SUCCESS(iosb.Status)) {
  USHORT dkheader;
  ZwReadFile(hFile,NULL,NULL,NULL,&iosb,&dkheader,2,NULL,NULL);

  if (NT_SUCCESS(iosb.Status) && dkheader=='KD') {

   ZwQueryInformationFile(hFile,&iosb,&fsi,sizeof(fsi),FileStandardInformation);
   fsi.EndOfFile.LowPart-=2;

   oldsize=append ? MemLen : 0;
   newsize=oldsize+fsi.EndOfFile.LowPart;
   MemReAlloc(newsize);
   ZwReadFile(hFile,NULL,NULL,NULL,&iosb,
     MemAdr+oldsize,fsi.EndOfFile.LowPart,NULL,NULL);
   if (NT_SUCCESS(iosb.Status) && !IsConsistent()) iosb.Status=0xC00001F1;
   if (NT_SUCCESS(iosb.Status)) {
    Dirty=append;
   }else{
    MemReAlloc(oldsize);
   }
  }else{
   iosb.Status=0xC00001F0;
  }
  ZwClose(hFile);
 }
 return iosb.Status;
}

NTSTATUS SaveFile(PCWSTR FileName) {
 UNICODE_STRING filename;
 HANDLE hFile;
 OBJECT_ATTRIBUTES oa;
 IO_STATUS_BLOCK iosb;

 RtlInitUnicodeString(&filename,FileName);
 InitializeObjectAttributes(&oa,&filename,OBJ_CASE_INSENSITIVE,NULL,NULL);

 ZwCreateFile(&hFile,FILE_WRITE_DATA|SYNCHRONIZE,&oa,&iosb,NULL,
   FILE_ATTRIBUTE_NORMAL,0,FILE_OVERWRITE_IF,
   FILE_SEQUENTIAL_ONLY|FILE_SYNCHRONOUS_IO_NONALERT,NULL,0);
 if (NT_SUCCESS(iosb.Status)) {

  USHORT dkheader='KD';
  ZwWriteFile(hFile,NULL,NULL,NULL,&iosb,&dkheader,2,NULL,NULL);

  ZwWriteFile(hFile,NULL,NULL,NULL,&iosb,MemAdr,MemLen,NULL,NULL);
  if (NT_SUCCESS(iosb.Status)) {
   if (iosb.Information==MemLen) {
    Dirty=0;		// okay!
   }else{
    iosb.Status=0xC00001F0;	// unvollständig!
   }
  }
  ZwClose(hFile);
 }
 return iosb.Status;
}


void SetTrap(UCHAR NewTrap) {
 KIRQL OldIrql;
 if (Trap!=NewTrap) {
  switch (Trap) {
   case 2: {
    UnloadDR();
    UnhookInt1();
    MmPageEntireDriver(NewInt1);
   }
  }
  Trap=NewTrap;
  switch (Trap) {
   case 2: {
    MmResetDriverPaging(NewInt1);
    HookInt1();
    LoadDR();
   }
  }
 }
}

void SetEmu(UCHAR NewEmu) {
 if (EmuMode == NewEmu) return;
 if (EmuMode == 2) {	// war: Aufnahme?
  EmuMode = NewEmu;	// <>2 setzen
  MemReAlloc(MemLen);	// Auf notwendige Größe verkleinern!
 }
 if (NewEmu == 2) {	// jetzt: Aufnahme?
  ULONG savelen = MemLen;
  MemReAlloc(PRE_ALLOC);	// Vor-Allokation!
  MemLen = savelen;
 }
 EmuMode = NewEmu;
}

/************************
 ** Nahtstellen zum NT **
 ************************/
struct REGINFO:public KEY_VALUE_FULL_INFORMATION {
 WCHAR space[255];
 inline NTSTATUS query(HANDLE key,wchar_t*us,ULONG&ResultLen) {
  UNICODE_STRING tag;
  RtlInitUnicodeString(&tag,us);
  return ZwQueryValueKey(key,&tag,KeyValueFullInformation,this,sizeof*this,
   &ResultLen);
 }
 inline void*data() {return (char*)this+DataOffset;}
};

NTSTATUS vdnt_init(UNICODE_STRING&RegPath) {
 HANDLE key;
 OBJECT_ATTRIBUTES oa;
 ULONG ResultLen;
 REGINFO info;

 GetInt1();	// INT1 sichern
 if (!OldInt1.LowPart) return 0xC00001F0;	// kein Pentium!

 InitializeObjectAttributes(&oa,&RegPath,OBJ_CASE_INSENSITIVE,NULL,NULL);

 ZwOpenKey(&key,KEY_QUERY_VALUE,&oa);

 NTSTATUS Status=info.query(key,L"Port",ResultLen);
 if (NT_SUCCESS(Status) && info.Type==REG_DWORD) {
  PhysBase=P586Base=PortBase=*(ULONG*)info.data();
 }

 Status=info.query(key,L"Phys",ResultLen);
 if (NT_SUCCESS(Status) && info.Type==REG_DWORD) {
  PhysBase=*(ULONG*)info.data();
 }

 Status=info.query(key,L"Load",ResultLen);
 if (NT_SUCCESS(Status) && info.Type==REG_SZ) {
  Status=LoadFile(PCWSTR(info.data()),false);
  if (NT_SUCCESS(Status)) {
   SetTrap(2);
   SetEmu(1);
  }
 }
 return STATUS_SUCCESS;
}

void vdnt_done() {
 SetEmu(0);
 SetTrap(0);
 MemReAlloc(0);
}

void A2U(PWSTR su, PCSZ sa, ULONG destlen) {
// ISO-Latin-1 zu Unicode konvertieren
 if (destlen) do {
  if (!(*su++ = *sa++)) break;
 }while (--destlen);
}

void DIOCPARAMS::PutResult(ULONG data, ULONG datalen) {
 if (cbOutBuffer>=datalen) {
  if (datalen<=4) {
   switch (cbOutBuffer) {
    case 1: *(PUCHAR)(lpvOutBuffer)=data; break;
    case 4: *(PULONG)(lpvOutBuffer)=data; datalen=4; break;
    default:*(PUSHORT)(lpvOutBuffer)=data; datalen=2;
   }
  }else{
   RtlCopyMemory(lpvOutBuffer,(void *)data,datalen); //hier: data=Zeiger
  }
  cbBytesReturned=datalen;
 }
}

NTSTATUS DIOCPARAMS::ctrl() {

 switch ((UCHAR)(dwIoControlCode >> 8)) {

  case 0: {			//Versions-Abfrage
   PutResult(0x0200,2);
  }break;

  case 1: {			//Zugriffs-Zähler
   switch ((UCHAR)(dwIoControlCode)) {
    case 0: {				//löschen
     RtlZeroMemory(&AC,sizeof(AC));
    }break;
    case 1: {				//setzen
     if (cbInBuffer>=sizeof(AC)) {
      RtlCopyMemory(&AC,lpvInBuffer,sizeof(AC));
     }
    }break;
    case 0xFF: {			//abfragen
     PutResult((ULONG)&AC,sizeof(AC));
    }break;
   }
  }break;

  case 3: {			//Emulations-Modus
   PutResult(EmuMode,1);
   switch ((UCHAR)dwIoControlCode) {
    case 0:
    case 1:
    case 2: {				//setzen
     SetEmu((UCHAR)dwIoControlCode);
    }break;
   }
  }break;

  case 5: {			//Datei-Funktionen
   wchar_t filename[256]=L"\\??\\";
   switch ((UCHAR)dwIoControlCode) {
    case 0: {				//Neu
     MemReAlloc(0);
     Dirty=0;
    }break;
    case 1: {				//Load
     A2U(filename+4,(PCSZ)lpvInBuffer,252);
     return LoadFile(filename,FALSE);
    }break;
    case 2: {				//Append
     A2U(filename+4,(PCSZ)lpvInBuffer,252);
     return LoadFile(filename,TRUE);
    }break;
    case 3: {				//Save
     __asm int 3;
     A2U(filename+4,(PCSZ)lpvInBuffer,252);
     return SaveFile(filename);
    }break;
    case 0xFE: {			//Dirty abfragen
     PutResult(Dirty,1);
    }break;
    case 0xFF: {			//Puffer-Länge abfragen
     PutResult(MemLen,4);
    }break;
   }
  }break;

  case 6: {			//Datei-Info
   PutResult((ULONG)&FileSta,sizeof(FileSta));
  }break;

  case 7: {			//Trap-Modus
   PutResult(Trap,1);
   switch ((UCHAR)dwIoControlCode) {
    case 0:
    case 2: {				//setzen
     SetTrap((UCHAR)dwIoControlCode);
    }break;
   }
  }break;

 }
 return STATUS_SUCCESS;
}

/*********************************************
 ** C++-Wrapper für NT-Device und NT-Driver **
 *********************************************/

struct Device:public DEVICE_OBJECT{
 inline NTSTATUS Control(IRP&);
 static NTSTATUS Control(DEVICE_OBJECT*pDO,IRP*pIrp) {return static_cast<Device*>(pDO)->Control(*pIrp);}
 inline NTSTATUS OpenClose(IRP&);
 static NTSTATUS OpenClose(DEVICE_OBJECT*pDO,IRP*pIrp) {return static_cast<Device*>(pDO)->OpenClose(*pIrp);}
};

NTSTATUS Device::Control(IRP&irp) {
 IO_STACK_LOCATION&IrpStack = *IoGetCurrentIrpStackLocation(&irp);
 DIOCPARAMS dioc={
 /*dwIoControlCode*/	(IrpStack.Parameters.DeviceIoControl.IoControlCode&CTL_MASK)>>2,
 /*lpvInBuffer*/	irp.AssociatedIrp.SystemBuffer,
 /*cbInBuffer*/		IrpStack.Parameters.DeviceIoControl.InputBufferLength,
 /*lpvOutBuffer*/	irp.AssociatedIrp.SystemBuffer,
 /*cbOutBuffer*/	IrpStack.Parameters.DeviceIoControl.OutputBufferLength};

 NTSTATUS Status=dioc.ctrl();

 irp.IoStatus.Information=dioc.cbBytesReturned; /* Anzahl Rückgabe-Bytes */
 irp.IoStatus.Status     =Status;
 IoCompleteRequest(&irp,IO_NO_INCREMENT);
 return Status;
}

NTSTATUS Device::OpenClose(IRP&irp) {
 irp.IoStatus.Information = 0;  /* Keine Rückgabe-Bytes */
 irp.IoStatus.Status = STATUS_SUCCESS;
 IoCompleteRequest(&irp,IO_NO_INCREMENT);
 return STATUS_SUCCESS;
}

struct Driver:public DRIVER_OBJECT {
 inline void Unload();
 static void Unload(DRIVER_OBJECT*p) {static_cast<Driver*>(p)->Unload();}
 inline NTSTATUS Entry(UNICODE_STRING&);
};

void Driver::Unload() {
/* Symbolischen Link wieder auflösen */
 UNICODE_STRING Win32DeviceName;
 vdnt_done();
 RtlInitUnicodeString(&Win32DeviceName,L"\\DosDevices\\VDongle.386");
 IoDeleteSymbolicLink(&Win32DeviceName);
 IoDeleteDevice(DeviceObject);
}

NTSTATUS Driver::Entry(UNICODE_STRING&RegistryPath) {
 // Symbolischen Link erzeugen, so dass Win32 darauf zugreifen kann
 PDEVICE_OBJECT DeviceObject;
 UNICODE_STRING NtDeviceName;
 UNICODE_STRING Win32DeviceName;
 NTSTATUS Status;

/* Treiber-Zeiger setzen */
 MajorFunction[IRP_MJ_CREATE]         = Device::OpenClose;
 MajorFunction[IRP_MJ_CLOSE]          = Device::OpenClose;
 MajorFunction[IRP_MJ_DEVICE_CONTROL] = Device::Control;
 DriverUnload                         = Unload;

/* Aus Treiber mache Gerät */
 RtlInitUnicodeString(&NtDeviceName,L"\\Device\\VDongle");
 Status = IoCreateDevice(this,0,&NtDeviceName,VDONGLE_TYPE,0,FALSE,
   &DeviceObject);
 if (!NT_SUCCESS(Status)) return Status;

 Status=vdnt_init(RegistryPath);
 if (!NT_SUCCESS(Status)) return Status;

/* Mache Gerät von Win32 aus sichtbar */
 RtlInitUnicodeString(&Win32DeviceName,L"\\DosDevices\\VDongle.386");
 Status = IoCreateSymbolicLink(&Win32DeviceName,&NtDeviceName);
 if (!NT_SUCCESS(Status)) IoDeleteDevice(DeviceObject);

 return Status;
}

extern "C" NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject,
				IN PUNICODE_STRING RegistryPath) {
 return static_cast<Driver*>(DriverObject)->Entry(*RegistryPath);
}
