	P386
	.XLIST
	include	tvmm2.inc
	include	debug2.inc
	.LIST
	locals

VDONGLE_Major_Ver	equ	2
VDONGLE_Minor_Ver	equ	0
VDONGLE_Ver		equ	VDONGLE_Major_Ver*256+VDONGLE_Minor_Ver
VDONGLE_Device_ID	equ     3B48h		;ab Version 1.02
;>You have been assigned a device ID of 3B48h for your VELGNOD.386 virtual
;>device.  This number is uniquely assigned to this device.

Declare_Virtual_Device  VDONGLE, VDONGLE_Major_Ver, VDONGLE_Minor_Ver,\
			VDONGLE_Control_Proc, VDONGLE_Device_ID,\
			3B000000h,VDONGLE_API,VDONGLE_API

;3C000000 ist die VPD_Init_Order des konkurrierenden VPD.VXD unter Windows95

;Die Version 2.00 arbeitet mit einer Ring-0-Vergleichsroutine
;und hat deshalb einen neuen API-Satz. Die Uhrzeit- und Netzwerkemulationen
;werden wegen praktischer Funktionslosigkeit ersatzlos gestrichen,
;die OUT-Zusammenfassung ist fest eingeschaltet - beim Laden "alter" Dateien
;werden gleiche OUTs automatisch zusammengefat.

;Int2F-API-Funktionen (NEU: fr alle VMs):
;AH=0	Versionsnummer besorgen (AH=Hauptversion, AL=Nebenversion)
;AH=1	NEU: Zugriff auf Struktur-Variable AccessCounter (Statistik):
;	AL=0: Nullsetzen
;	AL=1: Setzen, ES:BX=Zeiger
;	AL=0FFh: Abfragen, ES:BX=Zeiger
;AH=2	nicht benutzt (war: Callback und Puffer ausschalten)
;	...knnte spter das Setzen eines Zugriffs-Callbacks bewirken
;AH=3	Emulationsmodus schalten oder abfragen:
;	AL=0: ausschalten und Puffer vernichten
;	AL=1: Wiedergabe-Betrieb
;	AL=2: Aufnahme-Betrieb (Puffer wchst automatisch)
;	AL=0FFh: fragt aktuelle Stellung ab; Ergebnis in AL
;	Standard ist AUSgeschaltet.
;AH=4	Zugriff-Knack schalten oder abfragen:
;	AL=0: ausschalten,
;	AL=1: laut,
;	AL=2: leiser,
;	AL=0FFh: fragt aktuelle Stellung ab; Ergebnis in AL
;AH=5	NEU: Datei- und Puffer-Funktionen
;	AL=0: Puffer und DIRTY lschen,
;	AL=1: Datei laden, Dateiname in ES:BX, DIRTY:=0
;	AL=2: Datei anhngen, Dateiname in ES:BX, DIRTY:=1
;	AL=3: Datei speichern, Dateiname in ES:BX, DIRTY:=0
;	AL=4: DIRTY:=0 setzen
;	AL=5: Image laden (spter)
;	AL=6: Image anhngen (spter)
;	AL=7: Image speichern (spter)
;	AL=0FEh: DIRTY-Flag abfragen
;	AL=0FFh: Puffer-Lnge abfragen, Ergebnis in EAX
;	Ein direkter Zugriff auf den Speicherbereich ist nicht vorgesehen
;AH=6	NEU: Lade-Statistik holen, ES:BX=Statistik (IN- und OUT-Befehle)
;AH=7	Trapping-Methode whlen/abfragen:
;	AL=0: kein Trapping
;	AL=1: IOPM-Trapping
;	AL=2: 586Debug-Trapping
;	AL=0FFh: abfragen, Stellung in AL
;NEU: Die funktionsgleiche W32_DeviceIOControl-API arbeitet mit
;IO-Control-Code := AH*256 + AL
;
;Initialisierungen (in SYSTEM.INI, Sektion [VDongle]):
;Tick	Knackgerusch 0/1/2, Vorgabe: 0
;Port	Portadresse(*) der EMULATION via IOPM, Vorgabe LPT1 (oder 378h)
;P586	Portadresse(*) der EMULATION via Debug-Register, Vorgabe "Port"
;Phys	Portadresse(*) der HARDWARE, Vorgabe "Port"
;Kill	Portadresse(*), die im BIOS-Bereich zu ersetzen ist, Vorgabe 0
;Load	NEU: (unkomprimierte!) Datei, die anfnglich zu laden ist
;	(erspart den Aufruf von DKNACK.EXE)
;Trap	Trap-Modus 0/1/2, Vorgabe: 0 (bei "Load" Vorgabe 2)
;
;(*) Angabe als hexadezimale Zahl oder als LPTx (x=1..3)


TAccessCounter struc	;Zhler fr die Statistik
 ac_out	 dd	?	;OUT-Zugriffe
 ac_in	 dd	?	;IN-Zugriffe
 ac_fail dd	?	;Nicht gefunden ODER Nicht untersttzter IO-Befehl
 ac_resv dd	?
TAccessCounter ends

TFileStatistics	struc ;Datei-Info
 fs_out	dd	?
 fs_in	dd	?
TFileStatistics ends

DIOCParams STRUC
 Internal1		DD  ?
 VMHandle		DD  ?
 Internal2		DD  ?
 dwIoControlCode	DD  ?	;Steuercode
 lpvInBuffer		DD  ?	;Zeiger auf Eingabedaten
 cbInBuffer		DD  ?	;Zahl Eingabe-Datenbytes
 lpvOutBuffer		DD  ?	;Zeiger auf Ausgabepuffer
 cbOutBuffer		DD  ?	;Gre Ausgabepuffer
 lpcbBytesReturned	DD  ?	;Zurckgegebene Ausgabe-Bytes
 lpoOverlapped		DD  ?
 hDevice		DD  ?
 tagProcess		DD  ?
DIOCParams ENDS

;********************************
;*** Residente Daten (locked) ***
;********************************
VxD_Locked_DATA_SEG

PortBase	dd	378h	;Portadresse der Emulation
; Standard ist LPT1, falls vorhanden, sonst 378h
; (bei Sys_Dynamic_Init =37C, wegen strenden VPD.VXD bzw. VLPT.SYS)

P586Base	dd	378h	;Portadresse der Emulation
; wie PortBase, jedoch nur bei Verwendung der Debug-Register
; Einschrnkung wie bei Verwendung der IOPM besteht nicht

PhysBase	dd	378h	;Physikalische Portadresse
; Standard ist LPT1, falls vorhanden, sonst 378h
; (auch bei Sys_Dynamic_Init)

KillBase	dd	0	;Zu berschreibende Portadresse im BIOS

AC	TAccessCounter	<>
FileSta	TFileStatistics	<>
MemHand		dd	0	;Speicher-Handle (fr Win3.x)
MemAdr		dd	0	;Speicheradresse
MemLen		dd	0	;Speicherlnge in Bytes
MemPages	dd	0	;momentane Seitenzahl (als Cache)
MemIdx		dd	0	;Umlauf-Zeiger fr Vergleich
BufferAdr	dd	0	;FLAT-Pufferadresse auf Heap
BufferLen	EQU	2048	;Puffer-Lnge in WORDs (wie frher) 4KByte
;Aufbau des Puffers:
;1 WORD Anzahl OUT-Befehle (Fllstand in Bytes = (Anzahl+2)*2)
;x WORD OUT-Befehle, Lo=Byte, Hi=Offset 0..3
;1 WORD IN-Befehl, Lo=Byte, Hi=Offset+4 4..7
EmuMode		db	0	;Emulation Aus/Wiedergabe/Aufnahme
Tick		db	0	;Knackgerusch Aus/Laut/Leiser
Trap		db	0	;Trap-Modus Aus/IOPM/586Debug
Dirty		db	0	;Dirty-Flag

	align word
ChangedPort	dw	0	;zur Rcknahme des Patches beim Beenden
WasAddr		dw	0
OldInt1		df	0	;bleibt Null ohne Pentium


IDT	df	?
	align	dword

uptab label dword
	dd	OFFSET32 GetVer			;0
	dd	OFFSET32 GetSetAccessCounter	;1
	dd	OFFSET32 DoError		;2
	dd	OFFSET32 GetSetEmu		;3
	dd	OFFSET32 GetSetTick		;4
	dd	OFFSET32 LoadSaveFile		;5
	dd	OFFSET32 GetFileStatistics	;6
	dd	OFFSET32 TrapControl		;7

uptab_w32 label dword
	dd	OFFSET32 W32_GetVer		;0
	dd	OFFSET32 W32_GetSetAccessCounter;1
	dd	OFFSET32 W32_DoError		;2
	dd	OFFSET32 W32_GetSetEmu		;3
	dd	OFFSET32 W32_GetSetTick		;4
	dd	OFFSET32 W32_LoadSaveFile	;5
	dd	OFFSET32 W32_GetFileStatistics	;6
	dd	OFFSET32 W32_TrapControl	;7

UPTAB_LAST EQU 7

VxD_Locked_DATA_ENDS

;********************
;** VM-Nachrichten **
;********************

VxD_Locked_CODE_SEG
;VxD-obligatorische Steuer-Prozedur
BeginProc VDONGLE_Control_Proc
	Debug_Out "VDONGLE: ControlProc"
	Control_Dispatch Device_Init, On_Device_Init
	Control_Dispatch Init_Complete, On_Init_Complete
	Control_Dispatch Sys_VM_Init, On_Sys_VM_Init
	Control_Dispatch Sys_VM_Terminate, On_Sys_VM_Terminate
	Control_Dispatch VM_Init, On_VM_Init
	Control_Dispatch VM_Terminate, On_VM_Terminate
	Control_Dispatch 1bh, On_Dynamic_Init
	Control_Dispatch 1ch, On_Dynamic_Exit
	Control_Dispatch 23h, On_W32_DeviceIoControl
	clc
	ret
EndProc VDONGLE_Control_Proc

BeginProc On_Dynamic_Exit
	call	On_Sys_VM_Terminate
	mov	edx,[PortBase]
	LD	ecx,3
@@l:	VMMCall	00010116h	;Remove_IO_Handler
	inc	edx
	loopd	@@l
	call	MemClear
	jmp	ClearHeap
EndProc On_Dynamic_Exit

BeginProc On_Sys_VM_Init
	mov	al,[Trap]
	call	CheckTrapAL
	xchg	ah,al
	call	ITC_ON		;jetzt [Trap] wirksam machen
	clc
	ret
EndProc On_Sys_VM_Init

BeginProc On_VM_Init
;bei neu entstehender VM INT1 anzapfen
	cmp	[Trap],2
	jne	@@e
	call	HookInt1
@@e:	clc
	ret
EndProc On_VM_Init

BeginProc On_VM_Terminate
;bei sterbender VM INT1-Anzapfung abstellen (eigentlich unntig, oder?)
	cmp	[Trap],2
	jne	@@e
	call	UnhookInt1
@@e:	ret
EndProc On_VM_Terminate

BeginProc On_W32_DeviceIoControl
;PE: ESI=@DIOCParams
;PA: EAX=0: Funktion wird untersttzt (bei OPEN: ffnen OK)
;    EAX=-1: Funktion ist asynchron
;    sonst: EAX=Fehlercode
	mov	eax,[esi.dwIoControlCode]
	cmp	eax,-1
	je	@@ok
	cmp	ah,UPTAB_LAST
	ja	@@err
	movzx	ecx,ah
	clc
	cld
	call	[uptab_w32+ecx*4]
	jc	@@err
@@ok:	xor	eax,eax
	ret
@@err:	LD	eax,1
	ret
EndProc On_W32_DeviceIoControl

;*****************************
;** Debug-Register und Int1 **
;*****************************
USE_DA	equ	0000h		;0 oder 2000h

BeginProc LoadDR
;Lade Debugregister, VR: EAX
	mov	eax,DR7
	btr	eax,13		;zuerst: Debugregister-Trap ausschalten
	mov	DR7,eax
	db	0fh,20h,0e0h	;mov	eax,CR4		;"db" wegen TASM3
	BTS	eax,3		;PENTIUM Debug Extension aktivieren
	db	0fh,22h,0e0h	;mov	CR4,eax		;"db" wegen TASM3
	mov	eax,[P586Base]
	mov	DR0,eax
	mov	eax,DR7
	or	eax,000E0303h or USE_DA
	btr	eax,16		;EAX=xxxx xxxx xxxx 1110 xxXx xx11 xxxx xx11
	mov	DR7,eax
	ret
EndProc LoadDR

BeginProc UnloadDR
;Entlade Debugregister, VR: EAX
	mov	eax,DR7
	and	eax,not (000F0003h or USE_DA)
	mov	DR7,eax		;EAX=xxxx xxxx xxxx 0000 xxXx xxxx xxxx xx00
	ret
EndProc UnloadDR

BeginProc SetHook1
;PE: CX:EAX=neue Adresse fr INT1
;PA: CX:EAX=alte Adresse von INT1
	sidt	[IDT]
	mov	esi,[dword ptr IDT+2]
	xchg	ax,[esi+08h]		;Low-Teil Offset
	rol	eax,16
	xchg	ax,[esi+0Eh]		;High-Teil Offset
	rol	eax,16
	xchg	cx,[esi+0Ah]		;Segment
	ret
EndProc SetHook1

BeginProc SwapID
	pushfd
	pop	eax
	btc	eax,21
	push	eax
	popfd
	ret
EndProc SwapID

BeginProc GetInt1
;PA: [OldInt1]=Adresse von INT1, aber nur beim Pentium
	call	SwapID
	mov	esi,eax
	call	SwapID
	cmp	esi,eax
	jz	@@no_586
	sidt	[IDT]
	mov	esi,[dword ptr IDT+2]	;BASE
	mov	edi,offset OldInt1
	cld
	mov	ax,[esi+08h]		;Low-Teil Offset
	stosw
	mov	ax,[esi+0Eh]		;High-Teil Offset
	stosw
	mov	ax,[esi+0Ah]		;Segment
	stosw
@@no_586:
	ret
EndProc GetInt1

BeginProc HookInt1
;Faule Annahme: bei INT1 befindet sich bereits ein gltiger Gate-Deskriptor
;VR: EAX,CX,ESI; EFlags unverndert
	pushf
	 cli
	 mov	eax,offset NewInt1
	 mov	cx,cs
	 jmp	hook1
EndProc HookInt1

BeginProc UnhookInt1
;VR: EAX,CX,ESI; EFlags unverndert
	pushfd
	 cli
	 mov	eax,[dword ptr OldInt1]
	 mov	cx,[word ptr OldInt1+4]
hook1:	 cmp	[dword ptr OldInt1],0
	 jz	@@no_586
	 call	SetHook1
@@no_586:
	popfd
	ret
EndProc UnhookInt1

BeginProc HookAllVM
;Die IDT mu in allen VMs modifiziert werden
;PE: EDI=Zeiger auf Hook- oder Unhook-Funktion
	call	edi		;aktuelle VM sofort bearbeiten
	mov	ecx,ebx
@@l:	VMMCall	Get_Next_VM_Handle
	cmp	ecx,ebx
	je	@@e
	mov	esi,edi
	VMMCall	Schedule_VM_Event
	jmp	@@l
@@e:	ret
EndProc HookAllVM

;******************************************
;** Portzugriffe und Traps (IOPM und DR) **
;******************************************

BeginProc NewInt1 HIGH_FREQ NO_LOG
	pushad
	pushfd
	mov	eax,DR6
	btr	eax,0		;Zugriff auf Portadresse..Portadresse+3?
	jc	@@access
	btr	eax,13		;Zugriff auf Debug-Register?
	jc	@@accdr
	popfd
	popad
	jmp	[cs:OldInt1]	;weiter (zu SoftICE o..)
@@accdr:	;wenn schlimme Finger am Debugregister spielen
	popf
	mov	DR6,eax
	call	LoadDR		;nachladen!
	popad
	iret
@@access:
;bei jedem Portzugriff (LPT) steht in DX die Portadresse
;Faule Annahme: in AL steht das Datenbyte
	popf
	mov	DR6,eax		;Bit in DR6 lschen
	mov	ebp,esp		;CRS adressierbar machen (ab EIP -4!)
	push	ds es
	 mov	di,30h
	 bt	[ebp.Client_EFlags-4],VM_Bit	;V86-Mode?
	 jnc	@@protmode
;Opcode beschaffen; Adrerechnung je nach V86- oder Protmode
	 mov	ds,di
	 movzx	eax,[ebp.Client_CS-4]		;Real-Mode-CS
	 shl	eax,4
	 add	eax,[ebp.Client_EIP-4]
	 jmp	@@fromvm
;Annahme: Zugriff im Protected Mode mit lesbarem Code-Segment
@@protmode:
	 lds	eax,fword ptr [ebp.Client_EIP-4] ;Code-Zeiger
@@fromvm:
	 mov	al,[eax-1]		;Opcode
	 mov	ds,di
	 mov	es,di
;Richtung des Portzugriffs (Lesen oder Schreiben) ermitteln
	 xor	ecx,ecx
	 cmp	al,0ECh			;IN al,dx
	 je	@@supported		;mit AL=gelesenes Byte
	 BTS	ecx,Output_Bit
	 cmp	al,0EEh			;OUT dx,al
	 je	@@supported		;mit AL=geschriebenes Byte
	 inc	[AC.ac_fail]
 TRACE_OUT "VDONGLE.386: Nicht unterstuetzter Opcode #AL"
	 jmp	@@no_simple_IO
@@supported:
	 mov	eax,[ebp.Client_EAX]
	 push	ecx
	  call	IOCallback2		;etwas anders als IOCallback!
	 pop	ecx
	 cmp	ecx,Output
	 je	@@no_simple_IO
	 mov	[ebp.Client_AL],al	;Byte ggf. modifizieren
@@no_simple_IO:
	pop	es ds
	popad
	iret
EndProc NewInt1

;Ein Tick aus dem Lautsprecher ausgeben...
MakeTick proc
	cmp	[Tick],0	;eingeschaltet?
	jz	@@e		;nein, schweigen!
	push	eax
	pushf
	 BTST	[Tick],bit 1 ;LAUT eingeschaltet?
	 cli
	 jz	@@1		;nein, schweigen!
	 mov	al,10100000b	;Zhler 2 (Speaker) auf Modus 0 (Intr am Ende)
	 out	43h,al
	 mov	al,2		;512, rund 1/2 Millisekunde
	 out	42h,al		;Puls definierter Lnge ausgeben
@@1:	 in	al,61h
	 or	al,3
	 out	61h,al		;und hrbar machen!
	popf
	pop	eax
@@e:	ret
MakeTick endp

EndTick proc
	cmp	[Tick],1	;eingeschaltet (nicht LAUT?)
	jne	@@e		;nein, nichts tun!
InternalEndTick:
	push	eax
	pushf
	 cli
	 in	al,61h
	 and	al,not 3
	 out	61h,al		;und AUS!
	popf
	pop	eax
@@e:	ret
EndTick endp

BeginProc Compare1
;Einen Stringvergleich durchfhren
;PE: EAX=laufende Adresse im "Mem"
;    CLD!!
;PA: EAX=Adresse hinter dem verglichenen String
;    Z=1: Vergleich OK, dann [EAX-2]=IN-Byte (auerdem im Puffer)
;VR: EAX,ECX,ESI,EDI
	mov	edi,[BufferAdr]
	mov	esi,eax
	movzx	eax,word ptr [esi]	;Anzahl OUTs
	inc	eax
	mov	ecx,eax		;Lngen-WORD + Anzahl OUTs
	inc	eax
	lea	eax,[esi+eax*2]	;Neue Adresse
;nun: ESI,ECX und EDI gesetzt sowie EAX (das neue Ende) berechnet
	repe	cmpsw		;Lnge und OUTs vergleichen
	jnz	@@e
	movsb			;IN-Byte in den Puffer
	cmpsb			;IN-Adresse vergleichen
@@e:	ret
EndProc Compare1

BeginProc Compare2
;Noch einen Stringvergleich durchfhren, diesmal wird ein
;"Fehler-Koeffizient" geliefert, um die beste Passung zu finden
;Der String-Vergleich wird mit den jeweils LETZTEN OUT-Befehlen gemacht;
;eine unterschiedliche IN-Adresse liefert den maximal mglichen
;Fehlerkoeffizient
;PE: EAX=laufende Adresse im "Mem"
;    CLD!!
;PA: EAX=Adresse hinter dem verglichenen String
;    ECX=Fehler-Koeffizient (je kleiner, desto besser)
;VR: EAX,ECX,ESI
	mov	esi,eax
	movzx	eax,word ptr [esi]	;Anzahl OUTs in Mem
	lea	eax,[esi+eax*2+4]	;Neue Adresse
	push	edi eax edx
	 mov	edi,[BufferAdr]
;nun: ESI und EDI gesetzt sowie EAX (das neue Ende) berechnet
	 movzx	ecx,word ptr [edi]	;Anzahl OUTs im Puffer
	 mov	al,[eax-1]		;IN-Adresse in Mem
	 cmp	al,[edi+ecx*2+3]	;Vgl. IN-Adresse im Puffer
	 jne	@@bad			;Ungleich? Ganz schlecht!
	 movzx	eax,word ptr [esi]	;Anzahl OUTs in Mem
	 sub	eax,ecx			;Differenz=Anzahl Fehler
	 js	@@neg
	 add	edi,2			;hier: mehr in Mem als in Buffer
	 lea	esi,[esi+eax*2+2]	;vordere OUTs in Mem bergehen
	 jmp	@@poe
@@neg:					;hier: mehr in Buffer als in Mem
	 neg	eax			;Differenz positiv machen
	 sub	ecx,eax			;verbleibende zu vergleichende OUTs
	 add	esi,2
	 lea	edi,[edi+eax*2+2]	;vordere OUTs in Buffer bergehen
@@poe:	 mov	edx,eax			;Anzahl der Fehler durch Lngendiff.
	 add	edx,eax
	 add	edx,eax			;Lngenfehler mit Drei bewerten
;nun: ESI und EDI auf den "Anfang vom Ende" der OUT-Listen gesetzt,
;ECX=Lnge (Mindest-Anzahl OUTs) und EDX(!)=Fehlerzahl
	 jecxz	@@sf			;wenn keine OUT-Bytes
@@sl:	 cmpsb
	 je	@@eqd
	 inc	edx			;Datenfehler mit Eins bewerten
@@eqd:	 cmpsb
	 je	@@eqa
	 inc	edx			;Adrefehler mit Zwei bewerten
	 inc	edx
@@eqa:	 loop	@@sl
@@sf:	 push	edx
	 jmp	@@pe
@@bad:	 push	-1
@@pe:	 pop	ecx
	pop	edx eax edi
	ret
EndProc Compare2

PutInBuffer proc
;PE: AX=In/Out-Speicherwort
;PA: CY=1 bei Fehler
;    AL=IN-Byte
;VR: alle
	mov	esi,[BufferAdr]
	cmp	esi,1
	jc	@@e		;Kein Puffer - raus!
	movzx	edx,word ptr [esi]	;Aktuelle String-Lnge
	or	edx,edx		;Puffer leer?
	jz	@@1		;Dann auch immer eintragen!
	cmp	[esi+edx*2],ax	;Schon vorhanden?
	jz	@@e		;ja, ignorieren - und CY=0
@@1:	inc	edx
	mov	[esi+edx*2],ax	;Befehl eintragen
	bt	eax,10		;IN-Befehl?
	jc	ProcessBuffer
	cmp	edx,BufferLen	;Puffer voll?
	cmc
	jc	@@e		;Fehler, nichts tun!
	mov	[esi],dx	;String ist lnger geworden...
@@e:	ret
PutInBuffer endp

BeginProc ProcessBuffer		;CLD!!
;Routine wird bei IN-Befehl von PutInBuffer() aufgerufen
	cld
	push	offset @@resetbuffer	;bei RET ausfhren
	mov	dl,[EmuMode]
	dec	dl
	jz	@@play		;bei EmuMode=1
	dec	dl
	jz	@@record	;bei EmuMode=2
	ret
@@play:
	mov	eax,[MemLen]
	or	eax,eax
	jz	@@noplay	;Notbremse - und Null liefern
	mov	ebx,[MemAdr]
	add	ebx,eax		;Ende ins Register EBX
	mov	eax,[MemIdx]
	mov	edx,eax		;Startpunkt merken in EDX
@@pl:	call	Compare1
	jz	@@found
	cmp	eax,ebx		;Speicher-Ende erreicht?
	jb	@@p2
	mov	eax,[MemAdr]	;weiter von vorn
@@p2:	cmp	eax,edx		;Am Startpunkt angekommen?
	jnz	@@pl
	inc	[AC.ac_fail]
	;vielleicht ist das Dongleabfrageprogramm schlau und doof zugleich!
	;(Schickt zufllige Daten ans Dongle und will doch immer die gleiche
	; Byte-Sequenz beim Auslesen.)
	;Oder aber im zweiten Versuch den besten Treffer finden!
	;(Das ist zeitraubender, deshalb im zweiten Versuch)
	push	ebp
	 LD	edi,-1
@@suche2:
	 call	Compare2
	 cmp	ecx,edi
	 jnc	@@nomin		;Z=1 -> HIER: Nur erstes Minimum nehmen
	 mov	edi,ecx		;neues Minimum merken
	 mov	ebp,eax		;(End-)Adresse merken
@@nomin: cmp	eax,ebx		;Speicher-Ende erreicht?
	 jb	@@j2
	 mov	eax,[MemAdr]	;weiter von vorn
@@j2:	 cmp	eax,edx
	 jnz	@@suche2	;Eine ganze Runde herum
	 call	Compare2	;noch einer zum Vorrcken von EAX
	 cmp	edi,-1		;berhaupt etwas brauchbares gefunden?
	 je	@@nothing_found
	 mov	cl,[ebp-2]	;das nunmehr am besten passende IN-Byte
	pop	ebp
	cmp	[AC.ac_resv],edi
	jnc	@@found_cl
	mov	[AC.ac_resv],edi;Maximum eintragen
	jmp	@@found_cl
@@nothing_found:
	pop	ebp
@@found:
	mov	cl,[eax-2]	;das gesuchte IN-Byte
@@found_cl:
	cmp	eax,ebx		;Speicher-Ende erreicht?
	jb	@@p3
	mov	eax,[MemAdr]	;weiter von vorn
@@p3:	mov	[MemIdx],eax
	xchg	eax,ecx		;gotcha(r) mit einem Befehlsbyte
@@noplay:
	ret
@@record:
	push	eax		;IN-Byte retten zum Durchreichen
	 mov	esi,[BufferAdr]
	 movzx	eax,word ptr [esi]	;Anzahl OUTs
	 add	eax,2		;Anzahl WORDs
	 push	eax
	  add	eax,eax		;Anzahl Bytes
	  mov	edi,[MemLen]
	  add	eax,edi		;neues MemLen
	  call	MemReAlloc	;Speicher vergrern
	 pop	ecx
	 mov	eax,[MemAdr]	;ggf. neue(!) Adresse
	 add	edi,eax		;EDI=altes [MemLen] dazu
	 or	eax,eax
	pop	eax		;da ist das IN-Byte wieder!
	jz	@@recfailure
	rep	movsw		;an Puffer anhngen
	mov	[Dirty],1
	ret
@@recfailure:
	inc	[AC.ac_fail]
	ret
@@resetbuffer:
	mov	esi,[BufferAdr]
	mov	word ptr [esi],0
	ret
EndProc ProcessBuffer

;------------------------------------------------------------------------------
;   ENTRY:
;       EBX = VM Handle.
;       ECX = Type of I/O
;       EDX = Port number
;       EBP = Pointer to client register structure
;   EXIT:
;       EAX = data input or output depending on type of I/O
;------------------------------------------------------------------------------

BeginProc IOCallback High_Freq
	push	esi edi
	 sub	edx,[PortBase]
	 call	MakeTick
	 Dispatch_Byte_IO Fall_Through, @@O
	 inc	[AC.ac_in]
	 cmp	[EmuMode],1	;Wiedergabe?
	 je	@@no_phys_read	;nicht vom Port lesen
	 push	edx
	  add	edx,[PhysBase]
	  in	al,dx		;Emu AUS, vom Dongle lesen!
	 pop	edx
@@no_phys_read:
	 mov	ah,dl
	 or	ah,4		;Bit 2 als IN-Kennung setzen
	 jmp	@@put
@@O:
	 inc	[AC.ac_out]
	 cmp	[EmuMode],1	;Wiedergabe?
	 je	@@no_phys_write	;nicht zum Port schreiben
	 push	edx
	  add	edx,[PhysBase]
	  out	dx,al		;Emu AUS, zum Dongle schreiben!
	 pop	edx
@@no_phys_write:
	 mov	ah,dl
@@put:	 call	PutInBuffer	;liefert CY bei Fehler - wird ignoriert
	 call	EndTick
	 clc
	pop	edi esi
	ret
EndProc IOCallback

BeginProc IOCallback2 High_Freq
;fast dieselbe Routine, fr den Aufruf durch den Hardwarebreakpoint
;mit dem wichtigen Unterschied, da der I/O-Zugriff bereits gemacht wurde
;und hier KEINESFALLS ein Zugriff erfolgen darf, sonst Rekursion!
;(Ausnahme: die emulierte Portadresse ist nicht gleich der physikalischen.)
	sub	edx,[P586Base]
	cmp	edx,3
	je	@@bypass	;Die vierte Portadresse ganz ignorieren
	call	MakeTick
	cmp	ecx,Output	;=4
	je	@@O
	inc	[AC.ac_in]
	cmp	[EmuMode],1	;Wiedergabe?
	je	@@no_phys_read
	mov	ecx,[PhysBase]
	cmp	ecx,[P586Base]	;unterschiedlich?
	je	@@no_phys_read
	add	edx,ecx
	in	al,dx		;IN-Befehl auf richtiger Adresse nachholen
	sub	edx,ecx
@@no_phys_read:
	mov	ah,dl
	or	ah,4		;Bit 2 als IN-Kennung setzen
	jmp	@@put
@@O:
	inc	[AC.ac_out]
	cmp	[EmuMode],1	;Wiedergabe?
	je	@@no_phys_write
	mov	ecx,[PhysBase]
	cmp	ecx,[P586Base]	;unterschiedlich?
	je	@@no_phys_write
	add	edx,ecx
	out	dx,al		;OUT-Befehl auf richtiger Adresse nachholen
	sub	edx,ecx
@@no_phys_write:
	mov	ah,dl
@@put:	call	PutInBuffer	;liefert CY, wenn CallWindows erforderlich
	call	EndTick
@@bypass:
	ret
EndProc IOCallback2

;*************************
;** W32_DeviceIoControl **
;*************************

;Alle Routinen mit
;PE: AL=Subfunktionscode
;    ESI=@DIOCParams

BeginProc W32_ReturnByte
;PE: AL (oder AX oder EAX)=Datenbyte/word/dword
;VR: EAX,ECX, Z-Flag
	mov	ah,0		;hier: vorzeichenlos erweitern!
W32_ReturnWord:
	cwde
W32_ReturnDWord:
	mov	ecx,[esi.cbOutBuffer]
	jecxz	@@e
	mov	edi,[esi.lpvOutBuffer]
	dec	ecx
	jz	@@putbyte
	dec	ecx
	jz	@@putword
	dec	ecx		;3?
	jz	@@putword
	mov	[edi],eax
	push	4
	jmp	W32_PopRetBytes
@@putbyte:
	mov	[edi],al
	push	1
	jmp	W32_PopRetBytes
@@putword:
	mov	[edi],ax
	push	2
W32_PopRetBytes:		;zum Anspringen(!)
	 mov	eax,[esi.lpcbBytesReturned]
	pop	dword ptr [eax]
@@e:	ret
EndProc W32_ReturnByte

BeginProc W32_GetVer			;W32-DIOC Code=0
	mov	ax,VDONGLE_Ver
	jmp	W32_ReturnWord
EndProc W32_GetVer

BeginProc W32_GetSetAccessCounter	;W32-DIOC Code=1, Subcode=0/1/FF
	lea	edi,[AC]
	LD	ecx,4
	or	al,al
	jz	@@clear
	dec	al
	jz	@@set
	cmp	al,0FEh
	jz	@@get
	ret			;mit CY=1: Fehler!
@@clear:
	xor	eax,eax
	rep	stosd
	ret
@@set:
	cmp	[esi.cbInBuffer],16	;Gengend Bytes?
	jc	@@e		;Fehler!
	push	esi
	 mov	esi,[esi.lpvInBuffer]
	 rep	movsd		;setzen!
PopSI:	pop	esi
@@e:	ret
@@get:
	cmp	[esi.cbOutBuffer],16	;Gengend Bytes Platz?
	jc	@@e		;Fehler!
	push	esi
	 mov	esi,[esi.lpvOutBuffer]
	 xchg	esi,edi
	 rep	movsd
	pop	esi
	push	16
	 jmp	W32_PopRetBytes	;Anzahl gelieferter Bytes
EndProc W32_GetSetAccessCounter

BeginProc W32_GetSetEmu			;W32-DIOC Code=3, Subcode=0/1/2/FF
	LD	[MemIdx],[MemAdr]	;Indexzeiger auf Anfang
	push	esi
	 lea	esi,EmuMode
	 call	InternalGetSetSwitch
	pop	esi
	jmp	W32_ReturnByte
EndProc W32_GetSetEmu

BeginProc W32_GetSetTick		;W32-DIOC Code=4, Subcode=0/1/2/FF
	push	esi
	 lea	esi,Tick
	 call	InternalGetSetSwitch
	pop	esi
	jz	@@e
	cmp	al,1		;war Typ "1"?
	jne	@@e0
	call	InternalEndTick	;Sound AUS!
@@e0:	clc
@@e:	jmp	W32_ReturnByte
EndProc W32_GetSetTick

BeginProc W32_LoadSaveFile	;W32-DIOC Code=5, Subcode=0/1/2/3/4/FE/FF
	or	al,al
	jz	MemClear
	cmp	al,0FEh
	ja	@@Query
	je	@@Dirty
	cmp	al,4
	ja	DoError
	jz	ResDirty
	push	esi
	 push	offset32 PopSI
	 mov	esi,[esi.lpvInBuffer]	;Dateiname nach ESI
	 jmp	DispatchLoadSave	;je nach AL...
@@Query:
	mov	eax,[MemLen]	;Speichergre liefern
	cmp	[esi.cbOutBuffer],4	;ggf. CY setzen
	jmp	W32_ReturnDWord
@@Dirty:
	mov	al,[Dirty]
	jmp	W32_ReturnByte
EndProc W32_LoadSaveFile

BeginProc W32_GetFileStatistics		;W32-DIOC Code=6
	cmp	[esi.cbOutBuffer],8	;Gengend Bytes Platz?
	jc	DoError		;Fehler!
	push	esi
	 mov	edi,[esi.lpvOutBuffer]
	 lea	esi,[FileSta]
	 LD	ecx,2
	 rep	movsd
	pop	esi
	push	8		;Anzahl gelieferter Bytes
	 jmp	W32_PopRetBytes
EndProc W32_GetFileStatistics

BeginProc W32_TrapControl		;W32-DIOC Code=7, Subcode=0/1/2/FF
	push	esi
	 call	InternalTrapControl
	pop	esi
	jmp	W32_ReturnByte
EndProc W32_TrapControl

;*****************************
;** Protected-Mode Services **
;*****************************

BeginProc InternalGetSetSwitch
;PE: ESI=Byte-Schalter-Speicherzellen-Adresse
;    AL=neuer Wert oder Abfrage-Befehl (=0FFh)
;PA: AH=neuer Wert
;    AL=alter Wert
;    Z=1: Nichts hat sich gendert
;    CY=0
;VR: AX
	xchg	ah,al
	mov	al,[esi]
	cmp	ah,0FFh		;Abfrage?
	je	@@e		;Schalterstellung (und Z=1) liefern
	mov	[esi],ah	;neue Schalterstellung eintragen
	cmp	al,ah		;Nichts ndert sich? (auch Z=1 liefern)
	clc
@@e:	ret
EndProc InternalGetSetSwitch

BeginProc GetSetSwitch
;PE: ESI=Byte-Schalter-Speicherzellen-Adresse
;    EBP.Client_AL=neuer Wert oder Abfrage-Befehl (=0FFh)
;PA: AH=neuer Wert
;    AL=alter Wert (auch in EBP.Client_AL)
;    Z=1: Nichts hat sich gendert
;    CY=0
;VR: AX
	mov	al,[ebp.Client_AL]
GetSetSwitch1:
	call	InternalGetSetSwitch
	mov	[ebp.Client_AL],al
	ret
EndProc GetSetSwitch

GetVer proc			;PM-Service AH=0
	mov	[ebp.Client_AX],VDONGLE_Ver
	ret
GetVer endp

GetSetAccessCounter proc	;PM-Service AH=1, AL=0/1/FF
	cmp	[ebp.Client_AL],0
	jz	@@1
	Client_Ptr_Flat eax,ES,BX
	cmp	eax,-1
	je	DoError
	xchg	esi,eax			;User-Adresse
@@1:	lea	edi,[AC]		;VxD-interne Adresse
	LD	ecx,4			;4 DWords
	mov	al,[ebp.Client_AL]
	inc	al
	jz	@@query
	add	al,-2
	jz	@@set
	jc	@@e			;falsche Nummer
	xor	eax,eax
	rep	stosd			;Statistik lschen
	ret
@@query:
	xchg	esi,edi
@@set:
	rep	movsd
	clc
@@e:	ret
GetSetAccessCounter endp

W32_DoError:				;W32-DIOC Code=2
DoError proc			;PM-Service AH=2
	stc
	ret
DoError endp

GetSetEmu proc			;PM-Service AH=3 AL=0/1/2/FF
	mov	eax,[MemAdr]
	mov	[MemIdx],eax	;Indexzeiger auf Anfang
	lea	esi,EmuMode
	jmp	GetSetSwitch
GetSetEmu endp

GetSetTick proc			;PM-Service AH=4 AL=0/1/2/FF
	lea	esi,Tick
	call	GetSetSwitch
	jz	@@e
	cmp	al,1		;war Typ "1"?
	jne	@@e
	call	InternalEndTick	;Sound AUS!
@@e:	clc
	ret
GetSetTick endp

BeginProc LoadSaveFile		;PM-Service AH=5 AL=0/1/2/3/FF
	mov	al,[ebp.Client_AL]
	or	al,al
	jz	MemClear
	cmp	al,0FEh
	ja	@@Query
	je	@@Dirty
	cmp	al,4
	ja	DoError
	jz	ResDirty
	Client_Ptr_Flat eax,ES,BX
	cmp	eax,-1
	je	DoError
	xchg	esi,eax		;Dateiname nach ESI
	mov	al,[ebp.Client_AL]
DispatchLoadSave:
	cmp	al,3
	jz	SaveFile
	jmp	LoadFile
MemClear:
	xor	eax,eax
	mov	[Dirty],al
	jmp	MemReAlloc	;NEU: Speicher vernichten
@@Query:
	mov	eax,[MemLen]	;Speichergre liefern
	mov	[ebp.Client_EAX],eax
	ret
@@Dirty:
	mov	al,[Dirty]
	mov	[ebp.Client_AL],al
	ret
EndProc LoadSaveFile

GetFileStatistics proc		;PM-Service AH=6
	Client_Ptr_Flat eax,ES,BX
	cmp	eax,-1
	je	DoError
	xchg	edi,eax
	lea	esi,[FileSta]
	mov	ecx,2			;2 DWords
	rep	movsd			;Statistik kopieren
	clc
	ret
GetFileStatistics endp

BeginProc CheckTrapAL
;AL berprfen: falls =2 und kein Pentium, dann AL:=1
	cmp	al,2
	jne	@@e
	cmp	[dword ptr OldInt1],0
	jne	@@e
	dec	al			;anpassen!
@@e:	ret
EndProc CheckTrapAL

On_Sys_VM_Terminate:
	mov	al,0
BeginProc InternalTrapControl
;PE: AL=neuer Wert
	call	CheckTrapAL
	lea	esi,[Trap]
	call	InternalGetSetSwitch
	jmp	ITC
EndProc InternalTrapControl

BeginProc DisableTrappings
;Bei allen drei Ports globales Trapping ausschalten
;VR: ECX,EDX
	mov	edx,[PortBase]
	LD	ecx,3
@@l:	VMMCall	Disable_Global_Trapping
	inc	edx
	loop	@@l
	ret
EndProc DisableTrappings

BeginProc EnableTrappings
;Bei allen drei Ports globales Trapping einschalten
;VR: ECX,EDX
	mov	edx,[PortBase]
	LD	ecx,3
@@l:	VMMCall	Enable_Global_Trapping
	inc	edx
	loop	@@l
	ret
EndProc EnableTrappings

TrapControl proc			;Service AH=7
;Schaltet weder am IOPM-Hook noch an der ISR!
	mov	al,[ebp.Client_AL]
	call	CheckTrapAL		;aus 2 mach 1
	lea	esi,[Trap]
	call	GetSetSwitch1
	jz	@@e			;nichts tun!
ITC:
;nun: Alt=AL, Neu=AH
;Zunchst: alte Methode deaktivieren
	push	eax
	 cmp	al,1
	 jc	@@nix_aus
	 call	UnEditLPT		;Globale nderung zurcknehmen
	 cmp	al,1
	 jz	@@iopm_aus
	 call	UnloadDR
	 mov	edi,offset UnhookInt1
	 call	HookAllVM
	 jmp	@@nix_aus
@@iopm_aus:
	 call	DisableTrappings
@@nix_aus:
	pop	eax
;danach: neue Methode aktivieren
ITC_ON:	cmp	ah,1
	jc	@@nix_ein
	jz	@@iopm_ein
	mov	edx,[P586Base]
	call	EditLPT
	mov	edi,offset HookInt1
	call	HookAllVM
	call	LoadDR
	ret
@@iopm_ein:
	mov	edx,[PortBase]
	call	EditLPT
	call	EnableTrappings
@@nix_ein:
@@e:	ret
TrapControl endp

;=====================
;== Dateiverwaltung ==
;=====================

BeginProc IsConsistent
;Prft Konsistenz und entfernt Double-Outs
;PE: [MemAdr] und [MemLen]
;PA: CY=0, wenn konsistent
;    [MemAdr] und [MemLen] ggf. verndert
;VR: -
	pushad
	 mov	esi,[MemAdr]	;Anfangsadresse
	 mov	edi,esi
	 mov	ebx,esi
	 add	ebx,[MemLen]	;Endadresse+1
	 xor	eax,eax
	 xor	ecx,ecx
	 mov	[FileSta.fs_out],eax
	 mov	[FileSta.fs_in],eax
	 jmp	@@f		;Fugesteuerte Pseudo-Kopf-Schleife
@@la:	 mov	ebp,edi		;Zeiger auf Byte-Out-Zahl
	 lodsw
	 stosw
	 cmp	eax,BufferLen
	 ja	@@e		;Fehler - Lngen-WORD zu gro!
	 inc	[FileSta.fs_in]
	 add	[FileSta.fs_out],eax
	 xchg	ecx,eax
	 jecxz	@@nl
	 mov	edx,0FFFFh	;Vorhergehender OUT-Befehl
@@li:	 lodsw
	 cmp	ah,3		;Nur OUT-Befehle (AH=0, 1 oder 2)?
	 jnc	@@e		;Fehler: Kein OUT-Byte
	 cmp	eax,edx
	 je	@@eq		;Doppel-OUT nicht schreiben
	 stosw
	 jmp	@@ne
@@eq:	 dec	word ptr [ebp]	;ein OUT weniger!
	 dec	[FileSta.fs_out]
@@ne:	 xchg	edx,eax		;OUT-Befehl merken
	 loop	@@li
@@nl:	 lodsw
	 stosw
	 sub	ah,4
	 cmp	ah,3
	 jnc	@@e		;Fehler: Kein IN-Byte
@@f:	 cmp	esi,ebx
	 jc	@@la
	 jnz	@@e		;nicht glatt? Auch Fehler!
	 cmp	esi,edi		;Gab es Double-Outs?
	 je	@@ex		;nein, keine Speicherkorrektur
	 xchg	eax,edi
	 sub	eax,[MemAdr]	;neue Lnge
	 call	MemReAlloc	;Speicher verkleinern (sollte OK liefern)
	 clc
	 jmp	@@ex
@@e:	 stc
@@ex:	popad
	ret
EndProc IsConsistent

BeginProc lopen
;Datei ffnen mit LFN-Versuch
;PE: ESI=Dateiname ASCIIZ OEM
;    DL=Modus, 01h=LESEN, 11h=SCHREIBEN
;PA: CY=1: Fehler
;    EBX=Handle
	mov	ax,716Ch	;LFN-Funktion (OEM-Zeichensatz!)
@@again:
	mov	bh,02h		;kein INT24
	xor	ecx,ecx
	mov	dh,0
	stc
	call	Int21
	jnc	@@ebx
	cmp	ax,7100h
	stc
	jne	@@e		;Fehler (kein LFN)
	mov	ax,6C00h
	jmp	@@again		;Neuversuch ohne LFN
@@ebx:	xchg	ebx,eax
@@e:	ret
EndProc lopen

BeginProc lseek
;PE: AL=Bezugspunkt 0=Datei-Anfang, 1=Momentanposition, 2=Datei-Ende
;    BX=Handle
;    ECX=Position
;PA: EAX=Position absolut
	push	edx ecx
	 pop	dx cx		;CX:DX=Input
	 mov	ah,42h
	 call	Int21
	 push	dx ax		;DX:AX=Output
	 pop	eax edx
	ret
EndProc lseek

BeginProc lclose
;trivial!
	mov	ah,3Eh
Int21:	VxDint	21h
	ret
EndProc lclose

BeginProc LoadFile
;PE: ESI=Dateiname (LFN, OEM) unkomprimiert
;    AL=Append-Flag (=2)
	push	eax
	 mov	dl,01h		;ffnen, wenn existent
	 mov	bl,0		;Modus: Kompatibilitt, lesen
	 call	lopen
	 jc	@@epop
	 push	eax		;Platz auf Stack fr Kenn-Bytes "DK"
	  LD	ecx,2
	  mov	edx,esp
	  mov	ah,3Fh
	  call	Int21
	 pop	eax
	pop	edx
	jc	@@errc		;Fehler: Kann nicht lesen
	cmp	ax,'KD'
	jne	@@errc		;Fehler: ID nicht korrekt
	xor	ecx,ecx
	mov	al,2
	call	lseek		;Ergebnis: EAX=Dateilnge
	sub	eax,2
	push	eax
	 LD	ecx,2
	 mov	al,0
	 call	lseek		;Zurck hinter das 'DK'
	pop	edi
	xor	esi,esi		;Start des Ladens
	mov	eax,edi		;Lnge
	cmp	dl,2
	jne	@@noappend
	mov	esi,[MemLen]
	add	eax,esi
@@noappend:
	call	MemReAlloc	;mit EAX=neue Gre
	mov	edx,[MemAdr]
	or	edx,edx
	jz	@@errc		;Speicherproblem!
	add	edx,esi		;falls APPEND: nicht mit Null anfangen!
	mov	ecx,edi
	mov	ah,3Fh		;LESEN
	call	Int21
	jc	@@errm
	cmp	eax,ecx		;unvollstndig?
	jne	@@errm		;auch Fehler!
	call	IsConsistent	;mit [MemAdr] und [MemLen] als Parameter
	jc	@@errm
	call	lclose		;liefert ebenfalls CY
	jc	@@err
	cmp	[ebp.Client_AL],2
	setz	al
	mov	[Dirty],al	;Anhngen=schmutzig
	clc
	ret
@@errm:	;finally: Speicher zurcknehmen
	mov	eax,[MemLen]
	sub	eax,edi
	call	MemReAlloc
@@errc:	;finally: Datei schlieen
	call	lclose
@@err:	stc
	ret
@@epop:				;hier: CY ist bereits 1
	pop	eax
	ret
EndProc LoadFile

BeginProc SaveFile
;PE: ESI=Dateiname (ASCIIZ OEM)
;VR: alle (auer EBP)
	mov	dl,12h
	mov	bl,1		;Modus: Kompatibilitt, schreiben
	call	lopen
	jc	@@err
	push	'KD'
	 LD	ecx,2
	 mov	edx,esp
	 mov	ah,40h
	 call	Int21		;Header schreiben
	pop	eax
	jc	@@errc
	mov	ecx,[MemLen]
	mov	edx,[MemAdr]
	mov	ah,40h
	call	Int21
	jc	@@errc
	cmp	eax,ecx		;unvollstndig?
	jc	@@errc
	call	lclose
	jc	@@err
ResDirty:
	mov	[Dirty],0
	ret
@@errc:	call	lclose
@@err:	stc
	ret
EndProc SaveFile

;========================
;== Speicherverwaltung ==
;========================

BeginProc AllocHeap
;Lade- und Vergleichsspeicher belegen
;PA: EAX=[PufferAdr]
;VR: ECX,EDX
	VMMCall _HeapAllocate,<BufferLen*2,HeapZeroInit>
	mov	[BufferAdr],eax
	ret
EndProc AllocHeap

BeginProc ClearHeap
;VR: EAX,ECX,EDX
	xor	eax,eax
	xchg	[BufferAdr],eax
	VMMCall _HeapFree,<eax,0>
	ret
EndProc ClearHeap

BeginProc MemReAlloc
;Suchspeicher belegen, verndern oder freigeben, EAX=neue Gre in Bytes
;PA: siehe Memxxx-Speicherzellen; Adresse=0 bei Fehler
;VR: EAX,ECX,EDX
	mov	[MemLen],eax
	mov	ecx,[MemHand]
	or	eax,eax
	jz	@@free
	add	eax,0FFFh
	shr	eax,12		;Gre in 4-KB-Seiten aufrunden
	jecxz	@@alloc
	cmp	[MemPages],eax
	je	@@e
	mov	[MemPages],eax
	VMMCall _PageReAllocate,<ecx,eax,0>
	jmp	@@seta
@@alloc:
	mov	[MemPages],eax
	VMMCall _PageAllocate,<eax,PG_Sys,0,0,0,0,0,0>
	jmp	@@seta
@@free:
	jecxz	@@e		;schon freigegeben!
	VMMCall _PageFree,<ecx,0>
	xor	eax,eax
	cdq			;EDX:=0
	mov	[MemPages],eax
@@seta:	mov	[MemAdr],edx
	mov	[MemIdx],edx
	mov	[MemHand],eax
@@e:	ret
EndProc MemReAlloc

;========================
;== VM-API (Verteiler) ==
;========================

BeginProc VDONGLE_API
	Debug_Out "VDONGLE: API Call"
	movzx	eax,[ebp.Client_AH]
	cmp	eax,UPTAB_LAST
	ja	@@err
	clc
	call	[uptab+eax*4]
	jc	@@err
@@ok:	BRES	[ebp.Client_Flags],CF_Mask
	ret
@@err:	BSET	[ebp.Client_Flags],CF_Mask
	ret
EndProc VDONGLE_API

EditLpt proc
;PE: EDX=Portadresse
;PA: diese Portadresse wird global in 408h ff. eingetragen.
;    Falls keine Adresse frei ist, wird LPT3 berbgelt.
;    Falls die angegebene Adresse bereits vorhanden ist, wird nichts getan.
;    Die nderungen werden fr die Rcknahme durch UnEditLPT() gemerkt.
;VR: EAX,ECX,ESI
	mov	esi,408h
	xor	eax,eax
	LD	ecx,3
@@l:	lodsw			;1. freie LPT suchen oder letzte berbgeln
	cmp	eax,edx
	je	@@e		;kein Patch erforderlich!
	cmp	eax,[KillBase]
	je	@@1		;Portadresse ersetzen!
	or	eax,eax
	loopnz	@@l
@@1:	dec	esi
	dec	esi
	xchg	[esi],dx	;eintragen
	mov	[ChangedPort],si	;merken
	mov	[WasAddr],dx
	or	edx,edx		;alte Portadresse Null?
	jnz	@@e
	add	byte ptr ds:[411h],40h	;ein LPT mehr eintragen
@@e:	ret
EditLpt endp

UnEditLpt proc	;nderungen in der BIOS-Tabelle zurcknehmen
	xor	esi,esi
	xchg	[ChangedPort],si
	or	esi,esi
	jz	@@e
	mov	dx,[WasAddr]
	mov	[esi],dx
	or	dx,dx
	jnz	@@e
	sub	byte ptr ds:[411h],40h	;ein LPT weniger eintragen
@@e:	ret
UnEditLpt endp

VxD_CODE_ENDS

;****************************************
;*** Initialisierungs-Daten und -Code ***
;****************************************

VxD_IDATA_SEG
VDongle$ db	"VDongle",0
Port$	db	"Port",0
P586$	db	"P586",0
Phys$	db	"Phys",0
Tick$	db	"Tick",0
Trap$	db	"Trap",0
Kill$	db	"Kill",0
Load$	db	"Load",0
VxD_IDATA_ENDS

VxD_ICODE_SEG

GetEntry proc
;Lese SYSTEM.INI-Eintrag in Form LPTx oder als Hexzahl
;PE: EDI=Key-String, ESI=VDongle$
;PA: EAX=Portadresse
;    CY=1: kein oder ungltiger Eintrag
;VR: EAX,EDX
	VMMCall	Get_Profile_String
	jc	@@e		;Nicht gefunden? - Nicht auswerten!
	mov	eax,[edx]
	and	eax,00DFDFDFh	;Grobuchstaben!
	cmp	eax,'TPL'	;"LPT"?
	je	@@2		;ja
	VMMCall	Convert_Hex_String
	cmp	byte ptr [edx],1	;korrekt null-terminiert?
@@ecmc:	cmc
	ret
@@2:
	mov	al,[edx+3]	;Nummer...
	sub	al,'1'
	cmp	al,4
	jnc	@@ecmc
	movzx	eax,al
	movzx	eax,word ptr [408h+eax*2]	;LPT-Adresse...
	cmp	eax,1		;Null? (Wre ein Fehler!)
@@e:	ret
GetEntry endp

InitPhysBase proc
;Initialisiert die drei Portadressen mit der von LPT1
	movzx	eax,word ptr ds:[408h]	;LPT1-Portadresse
	or	eax,eax
	jz	@@e
LoadPhysBase:
	mov	[PhysBase],eax
	mov	[PortBase],eax
	mov	[P586Base],eax
@@e:	ret
InitPhysBase endp

;IOPM-I/O-Handler installieren (3 aufeinanderfolgende Adressen)
Try_Install_EDX_IO:
	mov	[PortBase],edx
Try_Install_IO_Handlers proc
	lea	esi,IOCallback
	mov	edx,[PortBase]
	LD	ecx,3		;mit 3 Bytes eine 3 in ECX!
@@l:	VMMcall Install_IO_Handler
	jc	@@e		;Schwerer Fehler
	inc	edx		;Nchste Portadresse
	loopd	@@l
@@e:	ret
Try_Install_IO_Handlers endp

BeginProc On_Device_Init
	Trace_Out "VDONGLE: Device_Init"
	call	InitPhysBase
;Knackgerusch ein/aus?
	lea	esi,VDongle$
	lea	edi,Tick$
	VMMCall	Get_Profile_Decimal_Int
	jbe	@@i4		;erschlgt CY und Z gleichermaen
	MAX	al,2
	mov	[Tick],al	;Wert ablegen
@@i4:	;Portadresse(n) besorgen
	lea	edi,Port$
	call	GetEntry
	jc	@@i1		;Nicht gefunden? - Nicht auswerten!
	call	LoadPhysBase
@@i1:	lea	edi,Phys$
	call	GetEntry
	jc	@@i2		;Nicht gefunden? - Nicht auswerten!
	mov	[PhysBase],eax
@@i2:	lea	edi,P586$
	call	GetEntry
	jc	@@i2a		;Nicht gefunden? - Nicht auswerten!
	mov	[P586Base],eax
@@i2a:	lea	edi,Kill$
	call	GetEntry
	jc	@@i2b		;Nicht gefunden? - Nicht auswerten!
	mov	[KillBase],eax
@@i2b:	jmp	@@i3
On_Dynamic_Init:		;Einsprung Dynamische Initialisierung
	VMMCall	Get_VMM_Version
	cmp	ah,4		;Windows95 erforderlich!!
	jc	@@err
	call	InitPhysBase
@@i3:	call	GetInt1
	call	AllocHeap	;Ein bissel Speicher bitte!
	call	Try_Install_IO_Handlers
	jnc	@@i5		;Okay!
	mov	dx,37Ch		;Versuch auf blicherweise freier Adresse
	call	Try_Install_EDX_IO
	jnc	@@i5		;Okay!
	mov	dx,27Ch		;Noch ein letzter Versuch...
	call	Try_Install_EDX_IO
	jc	@@e		;Fehler (Achselzucken); VxD trotzdem laden
@@i5:	call	DisableTrappings
@@e:	clc
@@err:	ret
EndProc On_Device_Init

On_Init_Complete proc
	pushad
	 lea	esi,VDongle$
	 push	esi
	  lea	edi,Trap$
	  VMMCall Get_Profile_Decimal_Int	;PA: CY und EAX=Zahl
	  jbe	@@1
	  mov	[Trap],al	;Debugregister erst bei Sys_VM_Init schalten!
@@1:	 pop	esi
	 lea	edi,Load$
	 VMMCall Get_Profile_String	;PA: CY und EDX=ASCIIZ
	 jc	@@e
	 mov	esi,edx
	 mov	al,1
	 call	LoadFile
	 jc	@@e
	 cmp	[Trap],0
	 jnz	@@trap_already_on
	 mov	[Trap],2	;Debugregister erst bei Sys_VM_Init schalten!
@@trap_already_on:
	 mov	[EmuMode],1	;Wiedergabe
@@e:	popad
	clc
	ret
On_Init_Complete endp

VxD_ICODE_ENDS
	END

